
program TestFarHeap;

uses FarHeap;

procedure MemStat;
begin
        Writeln('Free memory: ', MemAvail, '  Max free block: ', MaxAvail);
end;

procedure TestPtr(var P: Pointer; Size: Longint);
begin
     FarGetMem(P, Size);
     if Size <> 0 then asm
                les     di, P
                les     di, es:[di]
                mov     ax, 0AAh

                mov     cx, word ptr Size[2]
                jcxz    @@loop1done
                shl     cx, 1
     @@loop1:
                push    cx
                push    di
                mov     cx, 08000h
                cld
                rep     stosb
                mov     cx, es
                add     cx, 0800h
                mov     es, cx
                pop     di
                pop     cx
                loop    @@loop1
     @@loop1done:

                mov     cx, word ptr Size[0]
                cld
                rep     stosb
     end;
end;

var
        TestP: array [0 .. 6] of Pointer;

begin
        MemStat;

        TestPtr(TestP[0], 100);
        TestPtr(TestP[3], 100000);
        TestPtr(TestP[1], 1000);
        TestPtr(TestP[2], 10000);
        MemStat;

        FarFreeMem(TestP[3], 100000);
        MemStat;

        TestPtr(TestP[4], 70000);
        TestPtr(TestP[5], 30000);
        MemStat;

        TestPtr(TestP[6], 700);
        MemStat;

        FarFreeMem(TestP[0], 100);
        FarFreeMem(TestP[1], 1000);
        FarFreeMem(TestP[2], 10000);
        MemStat;

        FarFreeMem(TestP[4], 70000);
        FarFreeMem(TestP[5], 30000);
        MemStat;

        FarFreeMem(TestP[6], 700);
        MemStat;
end.
